.envrc 6.6 KB

123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120121122123124125126127128129130131132133134135136137138139140141142143144145146147148149150151152153154155156157158159160161162163164165166167168169170171172173174175176177178179180181182183184185186187188189190191192193194195196197198199200201202203204205206207208209210211212213214215216217218219220221222223224225226227228229230231232233234235236237238
  1. # This is the .envrc for sentry, for use with direnv.
  2. # It's responsible for enforcing a standard dev environment by checking as much state as possible, and either performing
  3. # initialization (e.g. activating the venv) or giving recommendations on how to reach the desired state.
  4. # It also sets useful environment variables.
  5. # If you'd like to override or set any custom environment variables, this .envrc will read a .env file at the end.
  6. set -e
  7. # Since direnv traps the EXIT signal we place the temp file under /tmp for the odd time
  8. # the script will use the EXIT path
  9. _SENTRY_LOG_FILE=$(mktemp /tmp/sentry.envrc.$$.out)
  10. exec > >(tee "$_SENTRY_LOG_FILE")
  11. exec 2>&1
  12. bold="$(tput bold)"
  13. red="$(tput setaf 1)"
  14. green="$(tput setaf 2)"
  15. yellow="$(tput setaf 3)"
  16. reset="$(tput sgr0)"
  17. # XXX: we can't trap bash EXIT, because it'll override direnv's finalizing routines.
  18. # consequently, using "exit" anywhere will skip this notice from showing.
  19. # so need to use set -e, and return 1.
  20. trap notice ERR
  21. # This is used to group issues on Sentry.io.
  22. # If an issue does not call info() or die() it will be grouped under this
  23. error_message="Unknown issue"
  24. log_level="info"
  25. notice() {
  26. [ $? -eq 0 ] && return
  27. cat <<EOF
  28. ${red}${bold}direnv wasn't able to complete execution.
  29. You may have been given some recommendations in the error message.
  30. Follow them, and then you'll need to redo direnv by running "direnv allow".${reset}
  31. If you're stuck or have questions, ask in #discuss-dev-tooling.
  32. EOF
  33. [ -z "${SENTRY_DEVENV_NO_REPORT+x}" ] && report_to_sentry
  34. }
  35. report_to_sentry() {
  36. if ! require sentry-cli; then
  37. curl -sL https://sentry.io/get-cli/ | bash
  38. fi
  39. sentry-cli send-event -m "$error_message" --logfile "$_SENTRY_LOG_FILE" --level $log_level
  40. rm "$_SENTRY_LOG_FILE"
  41. }
  42. require() {
  43. command -v "$1" >/dev/null 2>&1
  44. }
  45. warn() {
  46. cat <<EOF
  47. ${yellow}${bold}direnv: ${@}${reset}
  48. EOF
  49. }
  50. info() {
  51. cat <<EOF
  52. ${bold}direnv: ${@}${reset}
  53. EOF
  54. # info() calls happen multiple times in this script. The last info statement
  55. # is the one that will be used to group Sentry issues
  56. error_message=( "${@}" )
  57. }
  58. die() {
  59. cat >&2 <<EOF
  60. ${red}${bold}direnv FATAL: ${@}
  61. ${reset}
  62. EOF
  63. # When reporting to Sentry, this will allow grouping the errors differently
  64. # NOTE: The first line of the output is used to group issues
  65. error_message=( "${@}" )
  66. log_level="error"
  67. return 1
  68. }
  69. advice_init_venv() {
  70. venv_name="$1"
  71. deactivate 2>/dev/null || true
  72. info "To create a virtualenv, please type: python3.6 -m venv ${venv_name}"
  73. require "python3.6" ||
  74. die "You'll need to install python3, or make it available on your PATH.
  75. It's recommended to use pyenv - please refer to https://docs.sentry.io/development/contribute/environment"
  76. return 1
  77. }
  78. advice_install_sentry() {
  79. info "To install sentry, please type: make install-py-dev"
  80. return 1
  81. }
  82. advice_install_pre_commit() {
  83. info "To install pre-commit, please type: make setup-git"
  84. return 1
  85. }
  86. advice_install_yarn_pkgs() {
  87. info "To install yarn packages, please type: make install-js-dev"
  88. return 1
  89. }
  90. ### Environment ###
  91. # don't write *.pyc files; using stale python code occasionally causes subtle problems
  92. export PYTHONDONTWRITEBYTECODE=1
  93. # Always write stdout immediately. Very helpful for debugging
  94. export PYTHONUNBUFFERED=1
  95. # make sure we don't have any conflicting PYTHONPATH
  96. unset PYTHONPATH
  97. # don't check pypi for a potential new pip version; low-hanging fruit to save a bit of time
  98. export PIP_DISABLE_PIP_VERSION_CHECK=on
  99. # increase node's memory limit, required for our webpacking
  100. export NODE_OPTIONS=--max-old-space-size=4096
  101. # Frontend hot module reloader using `react-refresh`
  102. # Enable this by default for development envs (CI/deploys do not use envrc)
  103. export SENTRY_UI_HOT_RELOAD=1
  104. ## Notify of reporting to Sentry
  105. if [ -n "${SENTRY_DEVENV_NO_REPORT+x}" ]; then
  106. info "No development environment errors will be reported (since you've defined SENTRY_DEVENV_NO_REPORT)."
  107. else
  108. info "Development errors will be reported to Sentry.io."$'\n'" If you wish to opt-out, set SENTRY_DEVENV_NO_REPORT as an env variable."
  109. export SENTRY_DSN=https://23670f54c6254bfd9b7de106637808e9@o1.ingest.sentry.io/1492057
  110. fi
  111. ### System ###
  112. for pkg in \
  113. make \
  114. docker \
  115. chromedriver \
  116. pkg-config \
  117. pyenv \
  118. openssl; do
  119. if ! require "$pkg"; then
  120. die "You seem to be missing the system dependency: ${pkg}
  121. Please install homebrew, and run brew bundle."
  122. fi
  123. done
  124. ### Git ###
  125. info "Configuring git..."
  126. make setup-git-config
  127. ### Python ###
  128. venv_name=".venv"
  129. info "Activating virtualenv..."
  130. if [ ! -f "${venv_name}/bin/activate" ]; then
  131. info "You don't seem to have a virtualenv."
  132. # If the version doesn't match the contents of .python-version it will fail
  133. [[ $(pyenv version) ]] || \
  134. die "pyenv does not have the right Python version installed. Please run:
  135. make setup-pyenv && python3.6 -m venv ${venv_name}"
  136. advice_init_venv "$venv_name"
  137. fi
  138. # The user might be cd'ing into sentry with another non-direnv managed
  139. # (in that it would be automatically deactivated) virtualenv active.
  140. deactivate 2>/dev/null || true
  141. source "${venv_name}/bin/activate"
  142. # XXX: ideally, direnv is able to export PS1 as modified by sourcing venvs
  143. # but we'd have to patch direnv, and ".venv" isn't descriptive anyways
  144. unset PS1
  145. info "Ensuring proper virtualenv..."
  146. ${PWD}/scripts/ensure-venv.sh
  147. if ! require sentry; then
  148. info "Your virtualenv is activated, but sentry doesn't seem to be installed."
  149. # XXX: if direnv fails, the venv won't be activated outside of direnv execution...
  150. # So, it is critical that make install-py-dev is guarded by scripts/ensure-venv.
  151. advice_install_sentry
  152. fi
  153. ### pre-commit ###
  154. info "Checking pre-commit..."
  155. if ! require pre-commit; then
  156. info "Looks like you don't have pre-commit installed."
  157. advice_install_pre_commit
  158. fi
  159. ### Node ###
  160. info "Checking node..."
  161. if ! require node; then
  162. die "You don't seem to have node installed. Install volta (a node version manager): https://develop.sentry.dev/environment/#javascript"
  163. fi
  164. make node-version-check
  165. if [ ! -x "node_modules/.bin/webpack" ]; then
  166. info "You don't seem to have yarn packages installed."
  167. advice_install_yarn_pkgs
  168. fi
  169. PATH_add node_modules/.bin
  170. ### Overrides ###
  171. if [ -f '.env' ]; then
  172. info ".env found. Reading it..."
  173. dotenv .env
  174. fi
  175. cat <<EOF
  176. ${green}${bold}direnv: SUCCESS!
  177. ${reset}
  178. EOF
  179. if [ -z "${SENTRY_SILENCE_DIRENV_NOTICE:-}" ]; then
  180. cat <<EOF
  181. If you're stuck or have questions, ask in #discuss-dev-tooling.
  182. EOF
  183. fi
  184. # Since we can't use an EXIT routine we need to guarantee we delete the file here
  185. rm "$_SENTRY_LOG_FILE"